function init_followup(data){

	winElement = data.window;
	selectedMessageIds = data.selectedMessages;
	folder = current_folder;

	/**
	 * Implementao do widget de input-combobox
	 */
 
	(function( $ ) {
		$.widget( "ui.combobox", {
			_create: function() {
				var self = this,
					select = this.element.hide(),
					selected = select.children( ":selected" ),
					value = selected.val() ? selected.text() : "";
				var input = this.input = $( "<input>" )
					.insertAfter( select )
					.val( value )
					.autocomplete({
						delay: 0,
						minLength: 0,
						source: function( request, response ) {
							var matcher = new RegExp( $.ui.autocomplete.escapeRegex(request.term), "i" );
							response( select.children( "option" ).map(function() {
								var text = $( this ).text();
								if ( this.value && ( !request.term || matcher.test(text) ) )
									return {
										label: text.replace(
											new RegExp(
												"(?![^&;]+;)(?!<[^<>]*)(" +
												$.ui.autocomplete.escapeRegex(request.term) +
												")(?![^<>]*>)(?![^&;]+;)", "gi"
											), "<strong>$1</strong>" ),
										value: text,
										option: this
									};
							}) );
						},
						select: function( event, ui ) {
							ui.item.option.selected = true;
							self._trigger( "selected", event, {
								item: ui.item.option
							});
						},
						change: function( event, ui ) {
							if ( !ui.item ) {
								var matcher = new RegExp( "^" + $.ui.autocomplete.escapeRegex( $(this).val() ) + "$", "i" ),
									valid = false;
								select.children( "option" ).each(function() {
									if ( $( this ).text().match( matcher ) ) {
										this.selected = valid = true;
										return false;
									}
								});
								/*
								if ( !valid ) {
									// remove invalid value, as it didn't match anything
									$( this ).val( "" );
									select.val( "" );
									input.data( "autocomplete" ).term = "";
									return false;
								}
								*/
								if ( !valid ) {
									if(select.has('option[value="custom"]').length > 0) {
										select.find('option:last').val('custom').html($(this).val()).attr('selected', 'selected');
									} else {
										select.append(select.find('option:last').clone().val('custom').html($(this).val()));
										select.find('option[value="custom"]').attr('selected', 'selected');
									}
								}
							}
						}
					})
					.addClass( "ui-widget ui-widget-content ui-corner-left" );

				input.data( "autocomplete" )._renderItem = function( ul, item ) {
					return $( "<li></li>" )
						.data( "item.autocomplete", item )
						.append( "<a>" + item.label + "</a>" )
						.appendTo( ul );
				};

				this.button = $( "<button type='button'>&nbsp;</button>" )
					.attr( "tabIndex", -1 )
					.attr( "title", "Show All Items" )
					.insertAfter( input )
					.button({
						icons: {
							primary: "ui-icon-triangle-1-s"
						},
						text: false
					})
					.removeClass( "ui-corner-all" )
					.addClass( "ui-corner-right ui-button-icon" )
					.click(function() {
						// close if already visible
						if ( input.autocomplete( "widget" ).is( ":visible" ) ) {
							input.autocomplete( "close" );
							return;
						}

						// work around a bug (likely same cause as #5265)
						$( this ).blur();

						// pass empty string as value to search for, displaying all results
						input.autocomplete( "search", "" );
						input.focus();
					});
			},

			destroy: function() {
				this.input.remove();
				this.button.remove();
				this.element.show();
				$.Widget.prototype.destroy.call( this );
			}
		});
	})( jQuery );
	/**
	 * #END: Implementao do widget de input-combobox
	 */

	winElement.find('.button').button()
	.filter('.menu-configure-followupflag .cancel').click(function(){
		winElement.dialog("close");
	}).end()
	
	.filter('.menu-configure-followupflag .save').click(function(){	
				
		var backgroundColor = winElement.find('[name="backgroundColor"]').val();
		var followupflagId  = winElement.find('[name="name"] option:selected').val();
		if (followupflagId == 'custom') {
			DataLayer.put('followupflag', {name:winElement.find('[name="name"] option:selected').text(), uid:User.me.id});
			DataLayer.commit();
			
			followupflags = DataLayer.get('followupflag',{criteria:{order: 'id'}}, true);		
			followupflagId = followupflags[followupflags.length - 1].id;
			winElement.find('[name="name"] option[value="custom"]').val(followupflagId);
		}
		
		
		var isDone = winElement.find('[name="done"]').is(':checked') ? 1 : 0;
		var alarmDate = false;
		var doneDate  = false;
		var folder_name;
		var folders = [];
		var messages = [];
		var roles = get_selected_messages_search_role().split(',');
		for (var i=0; i < selectedMessageIds.length; i++ ){
			if (currentTab == 0) {
				folder_name = current_folder;
				var messageNumber = selectedMessageIds[i];
			}else{
				var tr = $('[role="'+roles[i]+'"]');
				folder_name = $(tr).attr('name'); 
				var id = $(tr).attr('id'); 
				var messageNumber = id.replace(/_[a-zA-Z0-9]+/,"");
			}
			folders.push(folder_name);
			
			var idFollowupflagged = winElement.find('[name="followupflagId"]').val();
			var followupflagged = DataLayer.merge({
				uid : User.me.id,
				followupflagId : followupflagId, 
				folderName : folder_name, 
				messageNumber : messageNumber,
				isDone: isDone,
				backgroundColor : backgroundColor
			}, !!idFollowupflagged ? {id: idFollowupflagged} : {});
			
			if (alarmDate = winElement.find('[name="alarmDate"]').datepicker("getDate")) {
				if (alarmTime = winElement.find('[name="alarmTime"]').datepicker("getDate")) {
					alarmDate.set({hour:alarmTime.getHours(), minute:alarmTime.getMinutes()});
				}
				followupflagged.alarmDeadline = alarmDate.toString('yyyy-MM-dd hh:mm:ss');
			}

			if (doneDate = winElement.find('[name="doneDate"]').datepicker("getDate")) {
				if (doneTime = winElement.find('[name="doneTime"]').datepicker("getDate")) {
					doneDate.set({hour:doneTime.getHours(), minute:doneTime.getMinutes()});
				}
				followupflagged.doneDeadline = doneDate.toString('yyyy-MM-dd hh:mm:ss');
			}
			
			/**
			 * Aplica o cone correspondente na lista de mensagens do expressoMail
			 */
			if(current_folder == folder_name){
				var flagged = $('#td_message_followup_' + messageNumber + ', tr[role="'+messageNumber+'_'+folder_name+'"] #td_message_followup_search_' + messageNumber).find(".flag-edited");
			} else{
				var flagged = $('tr[role="'+messageNumber+'_'+folder_name+'"] #td_message_followup_search_' + messageNumber).find(".flag-edited");
			}
			if(isDone){
				flagged.find("img").attr("src", "../prototype/modules/mail/img/flagChecked.png").css("margin-left","-3px");
			}else{
				flagged.find("img").attr("src", "../prototype/modules/mail/img/flagEditor.png").css("margin-left","0");			
			}
			

			if(current_folder == folder_name){
				$('#td_message_followup_' + messageNumber + ', ' + 
				'tr[role="'+messageNumber+'_'+folder_name+'"] #td_message_followup_search_' + messageNumber).find(".flag-edited").css("background", backgroundColor); 
			}else{
				$('tr[role="'+messageNumber+'_'+folder_name+'"] #td_message_followup_search_' + messageNumber).find(".flag-edited").css("background", backgroundColor); 
			}  
			/**
			 * Salva ou, caso j exista, atualiza
			 */
			DataLayer.put('followupflagged', followupflagged);
		}
		
		DataLayer.commit(false, false, function(data){
			followupflags = DataLayer.get('followupflagged',{criteria:{order: 'id'}}, true);		
			var id = followupflags[followupflags.length - 1].id;
			winElement.find('[name="followupflagId"]').val(id);
			winElement.find('.menu-configure-followupflag .save').button("option", "disabled", true);
			winElement.find('.menu-configure-followupflag .delete').button("option", "disabled", false);
		});
		
		var extend = DataLayer.get('followupflagged', {
			filter: ['AND', ['IN', 'messageNumber', selectedMessageIds], ['IN', 'folderName', folders]],
			criteria: {deepness: 1}
		});
		
		if(extend != "" || extend != 'undefined' || extend != []){
			for(var i = 0; i < extend.length; i++){
				if(onceOpenedHeadersMessages[extend[i].folderName]){
					if(onceOpenedHeadersMessages[extend[i].folderName][extend[i].messageNumber]){
						onceOpenedHeadersMessages[extend[i].folderName][extend[i].messageNumber]['followupflagged'] = {};
						DataLayer.merge(onceOpenedHeadersMessages[extend[i].folderName][extend[i].messageNumber]['followupflagged'], extend[i]);
					}
				}

			}
		} else {
			alert('erro ao salvar');
		}
	}).end()
	
	.filter('.menu-configure-followupflag .delete').click(function(){
		if (selectedMessageIds.length == 0) $(this).button("option", "disabled", true);
		
			var roles = get_selected_messages_search_role().split(',');
			for (var i=0; i < selectedMessageIds.length; i++ ){
				if (currentTab == 0) {
					folder_name = current_folder;
					var messageNumber = selectedMessageIds[i];
				}else{
					var tr = $('[role="'+roles[i]+'"]');
					folder_name = $(tr).attr('name'); 
					var id = $(tr).attr('id'); 
					var messageNumber = id.replace(/_[a-zA-Z0-9]+/,"");
				}
			if(onceOpenedHeadersMessages[folder_name][messageNumber]['followupflagged']){
				if(onceOpenedHeadersMessages[folder_name][messageNumber]['followupflagged'].id){
					var flag_id = onceOpenedHeadersMessages[folder_name][messageNumber]['followupflagged'].id;
					DataLayer.remove('followupflagged', flag_id);
					if(current_folder == folder_name){
						$('#td_message_followup_' + messageNumber + ', ' + 
						  'tr[role="'+messageNumber+'_'+folder_name+'"] #td_message_followup_search_' + messageNumber).find(".flag-edited").css("background", '#CCC');
						$('#td_message_followup_' + messageNumber + ', ' + 
							'tr[role="'+messageNumber+'_'+folder_name+'"] #td_message_followup_search_' + messageNumber).find(".flag-edited")
							.find("img").attr("src", "../prototype/modules/mail/img/flagEditor.png").css("margin-left","0");
					}else{
						$('tr[role="'+messageNumber+'_'+folder_name+'"] #td_message_followup_search_' + messageNumber).find(".flag-edited").css("background", '#CCC');
						$('tr[role="'+messageNumber+'_'+folder_name+'"] #td_message_followup_search_' + messageNumber).find(".flag-edited")
							.find("img").attr("src", "../prototype/modules/mail/img/flagEditor.png").css("margin-left","0");
					}

					onceOpenedHeadersMessages[folder_name][messageNumber]['followupflagged'] = undefined;
				}
			}
		}
		DataLayer.commit();
		winElement.dialog("close");
	});
	
	/**
	 * Se houver mudana, habilita o boto "Save"
	 */
	winElement.find(':input').change(function(event){
		if (event.keyCode != '27' && event.keyCode != '13')
			winElement.find('.menu-configure-followupflag .save').button("option", "disabled", false);
	}).keydown(function(event){
		if (event.keyCode != '27' && event.keyCode != '13')
			winElement.find('.menu-configure-followupflag .save').button("option", "disabled", false);
	});	
	
	winElement.find('.date').datepicker();
	winElement.find('.time').timepicker({});
	winElement.find('[name="name"]').combobox();

	winElement.find('[name="alarmDate"],[name="alarmTime"]').attr("disabled","disabled");
	
	winElement.find('[name="alarm"]').click(function(){
		if($(this).is(":checked")){
			winElement.find('[name="alarmDate"],[name="alarmTime"]').removeAttr("disabled");			
		}else{
			winElement.find('[name="alarmDate"],[name="alarmTime"]').attr("disabled","disabled");
		}
	});
	if(winElement.find('[name="alarm"]').is(":checked")){
		winElement.find('[name="alarmDate"],[name="alarmTime"]').removeAttr("disabled");
	}
	winElement.find('[name="done"]').click(function(){
		if($(this).is(":checked")){
			winElement.find(".input-done input").attr("disabled","disabled");
		}else{
			winElement.find(".input-done input").removeAttr("disabled");
		}
	});


	winElement.find(".followupflag-color-fields").hide();
	winElement.find(".followupflag-color.sample-list .sample-item").click(function(){
		winElement.find(".followupflag-color.sample-list .sample-item").removeClass("selected");
		$(this).addClass("selected");
		var color = $(this).attr('alt');
		winElement.find('[name="backgroundColor"]').css('background-color', color).val(color)
	});
	
	winElement.find(".followupflag-color.sample-list .sample-item.selected").trigger('click');
				
	winElement.find('[name="setColor"]').change(function(){		
		if(winElement.find('[name="setColor"]').val() == "default"){
			winElement.find(".followupflag-color.sample-list").show("fast");
			winElement.find(".followupflag-color-fields").hide();
			winElement.find(".followupflag-color.sample-list .sample-item.selected").trigger('click');
		} else if(winElement.find('[name="setColor"]').val() == "custom"){
			winElement.find(".followupflag-color-fields").show("fast");
			winElement.find(".followupflag-color.sample-list").hide();
			winElement.find(".colorwell").focus();
		}		
	});
	
	if(winElement.find('[name="setColor"] option:selected').val() == "custom"){
		winElement.find('[name="setColor"]').trigger("change");
	}

	var colorpickerPreviewChange = function(color) {
		winElement.find('.colorwell-selected').val(color).css('background-color', color);
		winElement.find('.flag-color-preview').css('background',color);
	} 

	var f = $.farbtastic(winElement.find('.colorpicker'), colorpickerPreviewChange);
	var selected;					
	winElement.find('.colorwell').each(function () {
		f.linkTo(this);
	}).focus(function() {
		if (selected) {
			$(selected).removeClass('colorwell-selected');
		}
		$(selected = this).addClass('colorwell-selected');
		f.linkTo(this, colorpickerPreviewChange);
		f.linkTo(colorpickerPreviewChange);
		
	});
	if(winElement.find('[name="setColor"] option:selected').val() == "custom"){
		winElement.find(".colorwell").focus();
	}

}


/**
 * constri as duas possveis janela de alerta, utilizando o mesmo template
 */

$('#main_table').ready(function(){
	var toIterate = [
		{
			attrDeadline: 'doneDeadline', 
			caption: {singular:'Voc tem uma mensagem concluindo hoje:', plural:"Voc tem %1 mensagens concluindo hoje:"},
			onOk: function(event){
				if($(event.target).parents('.followupflag-alarm').find('[name="stopAlert"]').is(':checked')){
					$.cookie("fadeCompleted", (new Date).toString("dd/MM/yyyy"), { expires: 1 });
				}
			},
			enable: ($.cookie("fadeCompleted") != (new Date).toString("dd/MM/yyyy"))
		},
		{
			attrDeadline: 'alarmDeadline', 
			caption: {singular:'Voc tem uma mensagem sinalizada para hoje:', plural:'Voc tem %1 mensagens sinalizadas para hoje:'},
			onOk: function(event){
				if($(event.target).parents('.followupflag-alarm').find('[name="stopAlert"]').is(':checked')){
					$.cookie("fadeAlarm", (new Date).toString("dd/MM/yyyy"), { expires: 1 });
				}
			},
			enable: ($.cookie("fadeAlarm") != (new Date).toString("dd/MM/yyyy"))
		}
	];

	while (it = toIterate.pop()){
		if (!it.enable) continue;
		
		var alarmInRange = DataLayer.get('followupflagged', {filter: ['AND', ['>', it.attrDeadline, (new Date()).set({hour:0, minute:0, second:0}).toString('yyyy-MM-dd 00:00:00')], ['<', toIterate.attrDeadline, (new Date()).set({hour:0, minute:0, second:0}).addHours(24).toString('yyyy-MM-dd 00:00:00')]], criteria: {deepness: 1}});
		if(alarmInRange.length > 0){
			for(var i=0; i<alarmInRange.length; i++){
				var date = Date.parseExact(alarmInRange[i].alarmDeadline, 'yyyy-MM-dd hh:mm:ss');
				alarmInRange[i].alarmDeadline = date.toString('hh:mm');
			}
			var caption = (alarmInRange.length == 1) ?
				get_lang(it.caption.singular):
				get_lang(it.caption.plural, alarmInRange.length);
				
			var data = {alarmInRange : alarmInRange, caption: caption};
			var dialogText = DataLayer.render("../prototype/modules/mail/templates/followupflag_alarm_list.ejs", data);
			
			/**
			 * A ltima dialog criada  a dialog mais ao alto
			 */
			var offsetHeight = $('.ZebraDialog.right-bottom:last').length ? 
				$(window).height() - $('.ZebraDialog.right-bottom:last').position().top : 0;

			/**
			 * Se for a primeira, desloca para cima do rodap do grid
			 * caso contrrio desloca para um pouco acima da ltima dialog criada
			 */
			offsetHeight = !offsetHeight ? 35 : offsetHeight + 20 ;
			var dialog = new $.Zebra_Dialog(dialogText, {
				'buttons':  ['Ok'],
				'modal': false,
				'vcenter_short_message': false,
				'position': ['right - 20', 'bottom - ' + offsetHeight.toString() ],
				'custom_class': 'right-bottom followupflag-alarm',
			}).dialog;

			$(".ZebraDialog.followupflag-alarm .ZebraDialog_Button0").click(it.onOk);
			
			$(".ZebraDialog.followupflag-alarm .display-options .more").click(function(event) {
				$(event.target).parents('.followupflag-alarm').find('.message-list').css('height', 'auto');
			});
			
		}		
	}
});
